      subroutine site_amp_nonlinear(
     :    per, v30, v30ref, pga_g, imodel_nl,
     :    a1, pga_g_low, a2,
     :    bnl, amp_nl)
      
* Input parameters: per, v30, v30ref, pga_g, imodel_nl, pga_low
* Output parameters: bnl (in terms of common log), amp_nl

* Compute the nonlinear site amp.
*       imodel_nl = 2 ! 1=CS; 2=GMA; 3=DMB1; 4=DMB2

* Preferred: imodel_nl = 3, a1, pga_g_low, a2 = 0.03, 0.06, 0.09g

* NOTE: pga in g!!!!!

* Dates: 08/01/05 - Written by D. Boore
*        07/03/06 - Add parameters a1, a2 for cubic smoothing

             
      call nonlin_b(imodel_nl, per, v30, 
     :    bnl, b1_per, b2_per, v1_per, v2_per)
             
      if (a1 .eq. a2) then ! no smoothing
        if (pga_g .ge. pga_g_low) then
          amp_nl = (pga_g/0.10)**bnl
        else
          amp_nl = (pga_g_low/0.10)**bnl
        end if
      else ! smoothing
        dx = alog(a2/a1)
        dy = bnl*alog(a2/pga_g_low)
        c =  (3.0*dy-bnl*dx)/dx**2
        d = -(2.0*dy-bnl*dx)/dx**3
        if (pga_g .le. a1) then
          amp_nl = (pga_g_low/0.10)**bnl
        else if (pga_g .gt. a1 .and. pga_g .le. a2) then
          amp_nl = exp( bnl*alog(pga_g_low/0.1) +
     :                    c*(alog(pga_g/a1))**2 +
     :                    d*(alog(pga_g/a1))**3 )
        else
          amp_nl = (pga_g/0.10)**bnl
        end if
      end if    

      return
      
      end
      
      
      include '\forprogs\nonlin_b.for'
 
 